#!/bin/bash


if  [[ "help" == "$1" || "$1" =~  [-]+help  ||  -z  "$1"   ]] ; then
	cat << __END
##### Usage
To be used in git-bash on Windows. So I am assumming that you have install git for Windows.

Please also have PDK installed.

The Script will take in a tar files which is from the release page. Extract and run PDK on it.
Only when the module is proven to have pass PDK validate, that it will be deployed to the Lab.

Install:
	Download the zip from the github. If you can clone the repo, that would be better. If you cannot just select the download as a zip,
instead of the cloning the repo. Unzip the zip file to install this script. In fact, you would have the whole repo. The script is placed in
the root of the module, so that it can be easily reference.

	To run the script use the full path $PWD/`basename $0`

Use:
	$0 *.tar.gz  = Will Process the all the tar.gz file in turn.

	The tar.gz files are the files which you download the github

By default, the module will be deployed/pushed to your personal repos....
i.e.
	$0 ./amodule.tar.gz ./bmodule.tar.gz = Deploy amodule and bmodule to your personal repos

When you are ready.
	You can use the following to deployed/pushed to your lab repos, by using.

	DEPLOYNOW=Y  $0 ./amodule.tar.gz ./bmodule.tar.gz = Deploy amodule and bmodule to your lab repos

	or
	export DEPLOYNOW=Y
	time $0 ./amodule.tar.gz ./bmodule.tar.gz =    Deploy amodule and bmodule to your lab repos, while it is timed.

	FYI, it took about 16mins to deploy 3 modules: *mongodb_*, *db2_* & *postgresql_*,

	To Bypass SDK, just bypasspdk=Y or export bypasspdk=Y

Logged Example:
	cd /h/Downloads/ ;
	time /h/Downloads/*databaseprojectcommon-dev_sooyean/deployme.sh ./*_mssql_*.tar.gz | tee ./deployme.sh_\$( date| tr ,:\  _ ).log

Get Token:
	$0 puppet_getPuppetEntrepriseToken

Clean up the databaseprojectcommon zip for download/update:
	$0	clean

Update  the databaseprojectcommon :
	$0	update


Sooyean - Sooyean.hoo@puppet.com
#######################
__END
	exit 0
fi
function clean(){
	cd $(dirname $0 ) ;
	cd .. ;
	ls -l  *database*common*zip
	rm  -f *database*common*zip
}
function update(){
	cd $(dirname $0 ) ;
	cd .. ;
	if [  -e *databaseprojectcommon-dev_sooyean.zip ] ; then
		rm -fr ./*_databaseprojectcommon-dev_sooyean ;
		mkdir  ./*_databaseprojectcommon-dev_sooyean ;
		#cd ./*_databaseprojectcommon-dev_sooyean
		unzip -o ./*_databaseprojectcommon-dev_sooyean.zip
	else
		echo "No UPDATE: Missing *_databaseprojectcommon-dev_sooyean.zip"
	fi;

}
function mymake(){
	makecmd="bash `dirname $0`/Makefile"
	makedir="$PWD"
	makeargs=''
	while [ ! -z "$1" ] ; do
		case $1 in
		  "-C")
		  	shift
		    makedir="$1"
		    ;;
		  "-f")
		  	shift
		    #makecmd="$1"
		    ;;
		  *)
		    makeargs="$makeargs $1"
		    ;;
		esac
		shift
	done;

	echo `eval echo cd "$makedir"`
	echo $makecmd $makeargs

	echo `eval echo cd "$makedir"` | bash -
	$makecmd $makeargs

}
if [ "$1" = "launch" ] ; then
	shift ;
	export project_loc=$PWD ;
	makeparams=`grep  'externaltools.ATTR_TOOL_ARGUMENTS' "$1" | sed -E          's/^.+value=.//g' | sed -E 's/&quot;/"/g' | sed -E 's/..>$//g' \
		|    sed -E 's/..project_loc:*_databaseprojectcommon./..\/*_databaseprojectcommon/g' | sed -E 's/..workspace_loc:\/*_databaseprojectcommon./..\/*_databaseprojectcommon/g'  \
        |    sed -E 's/..project_loc:*_mssql_*./..\/*_mssql_*/g' | sed -E 's/..workspace_loc:\/*_mssql_*./..\/*_mssql_*/g'  \
        |    sed -E 's/..project_loc:*_mongo_*./..\/*_mongo_*/g' | sed -E 's/..workspace_loc:\/*_mongo_*./..\/*_mongo_*/g'  \
        |    sed -E 's/..project_loc:*_db2_*./..\/*_db2_*/g' | sed -E 's/..workspace_loc:\/*_db2_*./..\/*_db2_*/g'  \
        |    sed -E 's/..project_loc:*_oracle_*./..\/*_oracle_*/g' | sed -E 's/..workspace_loc:\/*_oracle_*./..\/*_oracle_*/g'  \
        |    sed -E 's/..project_loc:*_postgresql_*./..\/*_postgresql_*/g' | sed -E 's/..workspace_loc:\/*_postgresql_*./..\/*_postgresql_*/g'  \
		`
	echo "=== make $makeparams"
	which make &&  eval make $makeparams
	which make || mymake $makeparams

	exit $?
fi;
puppetbin=/c/Program\ Files/Puppet\ Labs/Puppet/bin/puppet.bat
function puppet_getPuppetEntrepriseToken(){ #userid
	#puppetmasterurl=${puppetmasterurl:-$1} ;

	#userid=${userid:-$2} ;
	#userid=${puppetmasterurl:-$1} ;
	##UNSED passwd=${passwd:-$3} ;

	[ -z "$userid" ] && echo == No User Given
	[ -z "$userid" ] &&  return 0 ;

	puppetbin=${puppetbin:-/opt/puppetlabs/bin}

	SET_SERVER=$("$puppetbin" config print server)
	CONSOLE=${CONSOLE:-$SET_SERVER}

	cat << __END
		curl -k -X GET https://${CONSOLE}:4433/rbac-api/v1/auth/token -d '"{"login": "'${userid}'" , "password": "'${userid}'", "lifetime":"300d" }"'\
	 -H "Content-Type: application/json" --request POST
__END
	echo ==curl now==
		curl -k -X GET https://${CONSOLE}:4433/rbac-api/v1/auth/token -d '"{"login": "'${userid}'" , "password": "'${userid}'", "lifetime":"300d" }"'\
	 -H "Content-Type: application/json" --request POST || \
	 \
	 \
	curl -k -X GET https://${CONSOLE}:4433/rbac-api/v1/auth/token \
	  --cert $("$puppetbin" config print hostcert) \
	  --key $("$puppetbin" config print hostprivkey) \
	  --cacert $("$puppetbin" config print localcacert) \
	  -d '{"login": "'$(userid)'",  "lifetime":"300d" }' \
	  -H "Content-Type: application/json"




	type_header='Content-Type: application/json'
	uri="https://$("$puppetbin" config print server):4433/rbac-api/v1/auth/token"
	data='{"login": "${userid}",
	       "password": "${userid}"}'

	curl --insecure --header "$type_header" --request POST "$uri" --data "$data"

	# Clear all parameters
	while [ ! -z "$1" ] ; do
		shift
	done

}
[ -e `dirname $0`/coyinfo.sh ] && source `dirname $0`/coyinfo.sh
[ -e `dirname $0`/coyinfo.sh ] && cat `dirname $0`/coyinfo.sh

[ -z  "$bypasspdk" ] || bypasspdk="echo BYPASSED::"

[ -z  "$bypasspdkvalidate" ] || bypasspdkvalidate="echo BYPASSED::"
[ -z  "$bypasspdktest" ] || bypasspdktest="echo BYPASSED::"


function lapsedtime(){
 	now=$(date +%s)
	diff1=$((now-start1))
	diff=$((now-start))
    printf "        %s.%s seconds passed\n" "${diff1}" "0      $(( $diff1 / 60 ))min $(( $diff1 % 60 ))sec       $(( $diff1 / 60 / 60 ))h $(( ($diff1 / 60) % 60 ))min $(( $diff1 % 60 ))sec"
    printf "Overall %s.%s seconds passed\n" "${diff}" "0      $(( $diff / 60 ))min $(( $diff % 60 ))sec       $(( $diff / 60 / 60 ))h $(( ($diff / 60) % 60 ))min $(( $diff % 60 ))sec"
}
function timetest(){
	echo "========Begin TimeTest====="
	start=$(date +%s)
	sleep 3
	start1=$(date +%s)
	sleep 3
		lapsedtime
	sleep 3
		lapsedtime
	sleep 3
		lapsedtime
	exit 0;
}

while [ ! -e "$1" ] ; do
	$@ ;
	shift ;
	[ -z "$1" ] && exit 0;
done;

echo =====================Begin Deployment===========================
start=$(date +%s)
while [ ! -z "$1" ] ; do
	tarfile="$1"

	start1=$(date +%s)
	dirnamef=`basename $tarfile | sed -E 's/.tar.+$//g'`


	rm -fr "$dirnamef"
	tar -xzvf  "$tarfile"
	lapsedtime

	projectDir=$PWD
	pushd $PWD
	cd "$dirnamef"
	cat  .git/config

	url="${gitrepourl}/${deploypersonalpath}/${dirnamef}.git"
	[ -z "$DEPLOYNOW"   ] &&   url="${gitrepourl}/${deployprojectpath}/${dirnamef}.git"


	echo url=$url



	git  log -n3 --graph --all  --decorate=full
	echo ================================`git rev-parse HEAD`

	git checkout -b lab

	lapsedtime
	echo ====================================
	git remote add lab $url

	cat  .git/config

	echo ==============${bypasspdk} ${bypasspdkvalidate}==PDK Validate====================
	${bypasspdk} ${bypasspdkvalidate} $0 launch   `dirname $0`/PDK\ check_1\ \(project_loc\).launch
	lapsedtime
	echo ==============${bypasspdk} ${bypasspdkvalidate}==PDK Test====================
	${bypasspdk} ${bypasspdktest}     $0 launch   `dirname $0`/PDK\ test\ \(project_loc\).launch
	lapsedtime

	errid=$?
	[ $errid -ne 0 ] && exit $errid

	echo "Userid=`ls -l ~ | grep Users| sed -E 's/^.+Users//g' | cut -d \/ -f2 | sort -u`"
	git  log -n3 --graph --all  --decorate=full
	echo "====OKAY===To DEPLOY to  $url"
	echo "Control-C to stop ....Pause 10 Sec"
	sleep 10;
	echo ======DEPLOYMENT=START===== for $1 `git rev-parse HEAD` ;
	git push lab lab  2>&1
	echo ================================`git rev-parse HEAD`
	echo =======DONE===== for $1 ;
	lapsedtime
	popd
	shift ;
done ;
lapsedtime